<?php
/* utf8-marker = äöüß */

/*
 * Switchdebug_XH
 *
 * @author      Olaf Penschke    olape
 * @copyright   2019 Olaf Penschke
 * @version     1.0 RC1 (23.12.2020)
 * @link        http://olaf.penschke.net

 * @license     http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

============================================================================
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}

//**************************************************************************
// dynamic menu under plugin

if(function_exists('XH_registerStandardPluginMenuItems')) {
    XH_registerStandardPluginMenuItems(false);
}
//**************************************************************************
if(XH_wantsPluginAdministration('switchdebug')) {
    $o .= print_plugin_admin('on');

    // menu in the plugin header
    if(($admin != 'plugin_main') && ($admin != ''))
    {
        $o .= plugin_admin_common($action, $admin, $plugin);
    }
//**************************************************************************
//**************************************************************************
    $op_plugin_name = 'Switchdebug_XH';
    $op_plugin_version = '1.0 RC1';
    $op_copyright = '2019';
    $op_cms_version_arr = array('1.7.0',
                                '1.7.1',
                                '1.7.2',
                                '1.7.3',
                                '1.7.4',
                                'and higher');
    $op_php_version = '5.3';
//**************************************************************************
//**************************************************************************
    if(file_exists($pth['folder']['plugins'] . 'jquery/jquery.inc.php')) {
        include_once($pth['folder']['plugins'] . 'jquery/jquery.inc.php');
        include_jQuery();
    }
//**************************************************************************

    // display only on start page of plugin and under info
    if(($admin == '') || ($admin == 'plugin_main'))
    {
        $o .= '<div class="switchdebugxh_admin">';
        /*$o .= "\n" . '<h1>'
           . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';*/

        $o .= '<img class="switchdebugxh_admin_logo" alt="Logo Switchdebug_XH" src="' . $pth['folder']['plugins'] . 'switchdebug/img/logo-switchdebug_xh-200.png">';
        $o .= "\n" . '<h1>' . $plugin_tx['switchdebug']['admin_for'] . ' CMSimple_XH</h1>
        <p>Version: ' . $op_plugin_version . '</p>
        <p>' . $op_plugin_name . ', Copyright © ' . $op_copyright . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
        <p> </p>
        <p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">' . $plugin_tx['switchdebug']['admin_contact'] . '</a></p>
        <p> </p>
        <p><b>' . $op_plugin_name . '</b> ' . $plugin_tx['switchdebug']['admin_gplv3_1'] . ' <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.en.html">GPLv3</a> ' . $plugin_tx['switchdebug']['admin_gplv3_2'] . '</p>
        <hr>
        <p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr) . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';

//**************************************************************************
// System check
//**************************************************************************
        $o .= '<h2>System Check</h2>';
// CMSimple_XH Version
        $op_cms_version_tmp = CMSIMPLE_XH_VERSION;
        $op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
        if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
            $o .= '<p class="xh_success">' 
               . CMSIMPLE_XH_VERSION 
               . ' &#x2192 supported</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_fail">' 
               . CMSIMPLE_XH_VERSION 
               . ' &#x2192 I hope it is still supported. It was designed for ' 
               . $op_cms_version_arr[0] 
               . ' - ' 
               . end($op_cms_version_arr) 
               . '.</p>' 
               . "\n";
        }
// PHP Version
        if(version_compare(phpversion(), $op_php_version, '<')) {
            $o .= '<p class="xh_fail">PHP: ' 
               . phpversion() 
               . ' &#x2192 not supported</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_success">PHP: ' 
               . phpversion() 
               . ' &#x2192 supported</p>' 
               . "\n";
        }
// jQuery
        if(file_exists($pth['folder']['plugins'] . 'jquery/jquery.inc.php')) {
            $o .= '<p class="xh_success">' 
               . 'jQuery' 
               . ' &#x2192 is installed</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_fail">' 
               . 'jQuery' 
               . ' &#x2192 is not installed</p>' 
               . "\n";
        }
// write permissions
        $op_filename_arr = array($pth['folder']['plugins'] . 'switchdebug/css/', 
                                 $pth['folder']['plugins'] . 'switchdebug/css/stylesheet.css', 
                                 $pth['folder']['plugins'] . 'switchdebug/config/', 
                                 $pth['folder']['plugins'] . 'switchdebug/config/config.php', 
                                 $pth['folder']['plugins'] . 'switchdebug/languages/', 
                                 $pth['folder']['plugins'] . 'switchdebug/languages/' . $sl . '.php', 
                                 $pth['folder']['downloads']);
        foreach($op_filename_arr as $op_filename) {
            if(is_writable($op_filename)) {
                $o .= '<p class="xh_success">' 
                   . $op_filename 
                   . ' &#x2192 writable</p>' 
                   . "\n";
            } else {
                $o .= '<p class="xh_fail">' 
                   . $op_filename 
                   . ' &#x2192 not writable</p>' 
                   . "\n";
            }
        }
// XHdebug.txt check depending on presence
        if(file_exists($pth['folder']['downloads'] . 'XHdebug.txt')) {
            if(is_writable($pth['folder']['downloads'] . 'XHdebug.txt')) {
                $o .= '<p class="xh_success">' 
                   . $pth['folder']['downloads'] . 'XHdebug.txt' 
                   . ' &#x2192 writable</p>' 
                   . "\n";
            } else {
                $o .= '<p class="xh_fail">' 
                   . $pth['folder']['downloads'] . 'XHdebug.txt' 
                   . ' &#x2192 not writable</p>' 
                   . "\n";
            }
        }
        if(file_exists($pth['folder']['downloads'] . '_XHdebug.txt')) {
            if(is_writable($pth['folder']['downloads'] . '_XHdebug.txt')) {
                $o .= '<p class="xh_success">' 
                   . $pth['folder']['downloads'] . '_XHdebug.txt' 
                   . ' &#x2192 writable</p>' 
                   . "\n";
            } else {
                $o .= '<p class="xh_fail">' 
                   . $pth['folder']['downloads'] . '_XHdebug.txt' 
                   . ' &#x2192 not writable</p>' 
                   . "\n";
            }
        }
        $o .= '</div>';
    }
}
//**************************************************************************
// additional CSS-Class for configuration, stylesheet and language
// replaces the plugin name
if((isset($_GET['switchdebug'])) && (isset($_GET['admin']))) {
    if($_GET['admin'] == 'plugin_config') {
        $o = str_ireplace('<h1>Switchdebug', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer switchdebug_conf">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_stylesheet') {
        $o = str_ireplace('<h1>Switchdebug', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer switchdebug_stylesheet">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_language') {
        $o = str_ireplace('<h1>Switchdebug', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer switchdebug_language">' . $o . '</div>';
    }
}
//**************************************************************************
// POST or GET
if(((isset($_POST['switchdebugxh'])) 
&& ($_POST['switchdebugxh'] == 'off')) 
|| ((isset($_GET['switchdebugxh'])) 
&& ($_GET['switchdebugxh'] == 'off'))) {
    switchdebug_off();
}
if(((isset($_POST['switchdebugxh']))
&& ($_POST['switchdebugxh'] == 'on'))
|| ((isset($_GET['switchdebugxh']))
&& ($_GET['switchdebugxh'] == 'on'))) {
    switchdebug_on();
}

if(XH_ADM) {
    $ret = switchdebug_form();
    // form / button under Settings, if activated in Config
    if((isset($_GET['settings']))
    && ($plugin_cf['switchdebug']['view_settings'] == 'true')) {
        $o = $o . $ret[0];
    }
    // link in main menu, if activated in Config
    if($plugin_cf['switchdebug']['view_main'] == 'true') {
        $o .= PHP_EOL . '<script>
jQuery(document).ready(function(){
    $("#xh_adminmenu > ul").append("<li id=\"xh_adminmenu_switchdebug\">'
    . $ret[1]
    . '<\/li>");});
</script>' . PHP_EOL;
    }
    if(empty($plugin_cf['switchdebug']['view_xh-debug-text'])
    //&& count($errors) === 0) {
    && empty($errors)) {
        $o .= PHP_EOL
            . '<style>.xh_debug {display: none !important;}</style>'
            . PHP_EOL;
    }
}
//**************************************************************************
// XHdebug.txt / _XHdebug.txt - Switch ON
function switchdebug_on() {
    global $pth;

    // set URL for redirect after saving
    if($_SERVER['HTTP_REFERER']) {
        $location = $_SERVER['HTTP_REFERER'];
    } else {
        $location = CMSIMPLE_URL;
    }

    $_POST['switchdebugxh'] = '';
    $_GET['switchdebugxh'] = '';
    if(file_exists($pth['folder']['downloads'] . 'XHdebug.txt')) {
        unlink($pth['folder']['downloads'] . 'XHdebug.txt');
    }
    $fh = fopen($pth['folder']['downloads'] . '_XHdebug.txt', 'w');
    // set debug level fixed at 6
    fwrite($fh, '6');
    fclose($fh);
    chmod($pth['folder']['downloads'] . '_XHdebug.txt', 0644);
    header('Location: ' . $location, true, 303);
}
//**************************************************************************
// XHdebug.txt / _XHdebug.txt - Switch OFF
function switchdebug_off() {
    global $pth;

    // set URL for redirect after saving
    if($_SERVER['HTTP_REFERER']) {
        $location = $_SERVER['HTTP_REFERER'];
    } else {
        $location = CMSIMPLE_URL;
    }

    $_POST['switchdebugxh'] = '';
    $_GET['switchdebugxh'] = '';
    if(file_exists($pth['folder']['downloads'] . '_XHdebug.txt')) {
        unlink($pth['folder']['downloads'] . '_XHdebug.txt');
    }
    $fh = fopen($pth['folder']['downloads'] . 'XHdebug.txt', 'w');
    // set debug level fixed at 6
    fwrite($fh, '6');
    fclose($fh);
    chmod($pth['folder']['downloads'] . 'XHdebug.txt', 0644);
    header('Location: ' . $location, true, 303);
}
//**************************************************************************
function switchdebug_form() {
    global $pth, $plugin_tx;

    // debug is already enabled
    if(file_exists($pth['folder']['downloads'] . '_XHdebug.txt')) {
        $debugformvalue = 'off';
        $debugsubmitvalue = $plugin_tx['switchdebug']['debug_submit_off'];
        $debugsubmitlink = '<a id=\"switchdebug_a_off\" title =\"'
                         . $plugin_tx['switchdebug']['debug_linktitle_off'] 
                         . '\" href=\"?&switchdebug&admin=plugin_main&switchdebugxh=off\">' 
                         . $plugin_tx['switchdebug']['debug_link'] 
                         . '<\/a>';
    } else {
    // debug not enabled
        $debugformvalue = 'on';
        $debugsubmitvalue = $plugin_tx['switchdebug']['debug_submit_on'];
        // create link for main menu
        $debugsubmitlink = '<a id=\"switchdebug_a_on\" title =\"'
                         . $plugin_tx['switchdebug']['debug_linktitle_on'] 
                         . '\"href=\"?&switchdebug&admin=plugin_main&switchdebugxh=on\">' 
                         . $plugin_tx['switchdebug']['debug_link'] 
                         . '<\/a>';
    }
    // form / button under Settings
    $o_form = '<div class="switchdebugxh_form">' . "\n";
    $o_form .= '<h1>' . $plugin_tx['switchdebug']['settings_h1'] . '</h1>' . "\n";
    $o_form .= '<form name="switchdebugxh" action="?&switchdebug&admin=plugin_main" method="post">
        <input readonly type="hidden" name="switchdebugxh" value="' . $debugformvalue . '">
        <input type="submit" value="' . $debugsubmitvalue . '" id="debugsubmit">
        </form>' . "\n";
    $o_form .= '</div>' . "\n";

    return array($o_form, $debugsubmitlink);
}
//**************************************************************************

?>